diff --git a/web/pgadmin/utils/driver/psycopg2/connection.py b/web/pgadmin/utils/driver/psycopg3/connection.py
similarity index 82%
rename from web/pgadmin/utils/driver/psycopg2/connection.py
rename to web/pgadmin/utils/driver/psycopg3/connection.py
index 450573d02..e7551f922 100644
--- a/web/pgadmin/utils/driver/psycopg2/connection.py
+++ b/web/pgadmin/utils/driver/psycopg3/connection.py
@@ -1463,152 +1489,48 @@ Failed to reset the connection to the server due to following error:
     def _release(self):
         if self.wasConnected:
             if self.conn:
-                self.conn.close()
+                if self.async_ == 0:
+                    self.conn.close()
+                elif self.async_ == 1:
+                    self._close_async()
                 self.conn = None
             self.password = None
             self.wasConnected = False
 
-    def _wait(self, conn):
-        """
-        This function is used for the asynchronous connection,
-        it will call poll method in a infinite loop till poll
-        returns psycopg2.extensions.POLL_OK. This is a blocking
-        call.
+    def _close_async(self):
+        async def _close_conn(conn):
+            if conn:
+                await conn.close()
+        asyncio.run(_close_conn(self.conn))
 
-        Args:
-            conn: connection object
-        """
-        while True:
-            state = conn.poll()
-            if state == psycopg2.extensions.POLL_OK:
-                break
-            elif state == psycopg2.extensions.POLL_WRITE:
-                select.select([], [conn.fileno()], [],
-                              self.ASYNC_WAIT_TIMEOUT)
-            elif state == psycopg2.extensions.POLL_READ:
-                select.select([conn.fileno()], [], [],
-                              self.ASYNC_WAIT_TIMEOUT)
-            else:
-                raise psycopg2.OperationalError(
-                    "poll() returned %s from _wait function" % state)
+    def _wait(self, conn):
+        pass
 
     def _wait_timeout(self, conn):
-        """
-        This function is used for the asynchronous connection,
-        it will call poll method and return the status. If state is
-        psycopg2.extensions.POLL_WRITE and psycopg2.extensions.POLL_READ
-        function will wait for the given timeout.This is not a blocking call.
-
-        Args:
-            conn: connection object
-            time: wait time
-        """
-
-        while True:
-            state = conn.poll()
-
-            if state == psycopg2.extensions.POLL_OK:
-                return self.ASYNC_OK
-            elif state == psycopg2.extensions.POLL_WRITE:
-                # Wait for the given time and then check the return status
-                # If three empty lists are returned then the time-out is
-                # reached.
-                timeout_status = select.select(
-                    [], [conn.fileno()], [], self.ASYNC_TIMEOUT
-                )
-                if timeout_status == ([], [], []):
-                    return self.ASYNC_WRITE_TIMEOUT
-            elif state == psycopg2.extensions.POLL_READ:
-                # Wait for the given time and then check the return status
-                # If three empty lists are returned then the time-out is
-                # reached.
-                timeout_status = select.select(
-                    [conn.fileno()], [], [], self.ASYNC_TIMEOUT
-                )
-                if timeout_status == ([], [], []):
-                    return self.ASYNC_READ_TIMEOUT
-            else:
-                raise psycopg2.OperationalError(
-                    "poll() returned %s from _wait_timeout function" % state
-                )
+        pass
 
     def poll(self, formatted_exception_msg=False, no_result=False):
-        """
-        This function is a wrapper around connection's poll function.
-        It internally uses the _wait_timeout method to poll the
-        result on the connection object. In case of success it
-        returns the result of the query.
+        cur = self.__async_cursor
 
-        Args:
-            formatted_exception_msg: if True then function return the formatted
-                                     exception message, otherwise error string.
-            no_result: If True then only poll status will be returned.
-        """
+        if self.conn.pgconn.is_busy():
+            status = 3
+        else:
+            status = 1
 
-        cur = self.__async_cursor
         if not cur:
             return False, self.CURSOR_NOT_FOUND
 
+        result = None
+        self.row_count = 0
+        self.column_info = None
+
         current_app.logger.log(
             25,
             "Polling result for (Query-id: {query_id})".format(
                 query_id=self.__async_query_id
             )
         )
-
-        is_error = False
-        try:
-            status = self._wait_timeout(self.conn)
-        except psycopg2.OperationalError as op_er:
-            errmsg = \
-                self._formatted_exception_msg(op_er, formatted_exception_msg)
-            is_error = True
-        except psycopg2.Error as pe:
-            errmsg = self._formatted_exception_msg(pe, formatted_exception_msg)
-            is_error = True
-            if self.conn.closed:
-                raise ConnectionLost(
-                    self.manager.sid,
-                    self.db,
-                    self.conn_id[5:]
-                )
-        except OSError as e:
-            # Bad File descriptor
-            if e.errno == 9:
-                raise ConnectionLost(
-                    self.manager.sid,
-                    self.db,
-                    self.conn_id[5:]
-                )
-            else:
-                raise e
-
-        if self.conn.notices and self.__notices is not None:
-            self.__notices.extend(self.conn.notices)
-            self.conn.notices.clear()
-
-        # Check for the asynchronous notifies.
-        self.check_notifies()
-
-        # We also need to fetch notices before we return from function in case
-        # of any Exception, To avoid code duplication we will return after
-        # fetching the notices in case of any Exception
-        if is_error:
-            return False, errmsg
-
-        result = None
-        self.row_count = 0
-        self.column_info = None
-
-        if status == self.ASYNC_OK:
-
-            # if user has cancelled the transaction then changed the status
-            if self.execution_aborted:
-                status = self.ASYNC_EXECUTION_ABORTED
-                self.execution_aborted = False
-                return status, result
-
-            # Fetch the column information
+        if not self.conn.pgconn.is_busy():
             if cur.description is not None:
                 self.column_info = [
                     desc.to_dict() for desc in cur.ordered_description()
@@ -1619,8 +1541,8 @@ Failed to reset the connection to the server due to following error:
                     col['pos'] = pos
                     pos += 1
 
-            self.row_count = cur.rowcount
-            if not no_result and cur.rowcount > 0:
+            self.row_count = cur.get_rowcount()
+            if not no_result and cur.get_rowcount() > 0:
                 result = []
                 # For DDL operation, we may not have result.
                 #
@@ -1628,13 +1550,11 @@ Failed to reset the connection to the server due to following error:
                 # and DDL operations, we need to rely on exception to
                 # figure that out at the moment.
                 try:
-                    for row in cur:
-                        new_row = []
-                        for col in self.column_info:
-                            new_row.append(row[col['name']])
-                        result.append(new_row)
+                    result = cur.fetchalltupple()
 
-                except psycopg2.ProgrammingError:
+                except psycopg.ProgrammingError:
+                    result = None
+                except psycopg.Error:
                     result = None
 
         return status, result
@@ -1709,7 +1629,7 @@ Failed to reset the connection to the server due to following error:
 
             try:
                 with ConnectionLocker(self.manager.kerberos_conn):
-                    pg_conn = psycopg2.connect(
+                    pg_conn = psycopg.connect(
                         host=self.manager.local_bind_host if
                         self.manager.use_ssh_tunnel else self.manager.host,
                         hostaddr=self.manager.local_bind_host if
@@ -1717,7 +1637,7 @@ Failed to reset the connection to the server due to following error:
                         self.manager.hostaddr,
                         port=self.manager.local_bind_port if
                         self.manager.use_ssh_tunnel else self.manager.port,
-                        database=self.db,
+                        dbname=self.db,
                         user=self.manager.user,
                         password=password,
                         passfile=get_complete_file_path(self.manager.passfile),
@@ -1731,7 +1651,8 @@ Failed to reset the connection to the server due to following error:
                         sslcompression=True if self.manager.sslcompression
                         else False,
                         service=self.manager.service,
-                        connect_timeout=self.manager.connect_timeout
+                        connect_timeout=self.manager.connect_timeout,
+                        cursor_factory=DictCursor
                     )
 
                 # Get the cursor and run the query
@@ -1742,9 +1663,9 @@ Failed to reset the connection to the server due to following error:
                 pg_conn.close()
                 pg_conn = None
 
-            except psycopg2.Error as e:
+            except psycopg.Error as e:
                 status = False
-                if e.pgerror:
+                if hasattr(e, 'pgerror'):
                     msg = e.pgerror
                 elif e.diag.message_detail:
                     msg = e.diag.message_detail
@@ -1794,7 +1715,7 @@ Failed to reset the connection to the server due to following error:
 
     def _formatted_exception_msg(self, exception_obj, formatted_msg):
         """
-        This method is used to parse the psycopg2.Error object and returns the
+        This method is used to parse the psycopg.Error object and returns the
         formatted error message if flag is set to true else return
         normal error message.
 
@@ -1804,10 +1725,13 @@ Failed to reset the connection to the server due to following error:
             message
 
         """
-        if exception_obj.pgerror:
+        if hasattr(exception_obj, 'pgerror'):
             errmsg = exception_obj.pgerror
-        elif exception_obj.diag.message_detail:
-            errmsg = exception_obj.diag.message_detail
+        elif hasattr(exception_obj, 'diag') and \
+            hasattr(exception_obj.diag, 'message_detail') and\
+                exception_obj.diag.message_detail is not None:
+            errmsg = exception_obj.diag.message_detail + \
+                exception_obj.diag.message_primary
         else:
             errmsg = str(exception_obj)
 
@@ -1920,20 +1844,16 @@ Failed to reset the connection to the server due to following error:
             return False
         return True
 
-    def check_notifies(self, required_polling=False):
+    def check_notifies(self, n=None):
         """
         Check for the notify messages by polling the connection or after
         execute is there in notifies.
         """
-        if self.conn and required_polling:
-            self.conn.poll()
 
-        if self.conn and hasattr(self.conn, 'notifies') and \
-                len(self.conn.notifies) > 0:
-            self.__notifies.extend(self.conn.notifies)
-            self.conn.notifies = []
-        else:
-            self.__notifies = []
+        if n:
+            if self.__notifies is None:
+                self.__notifies = []
+            self.__notifies.append(n)
 
     def get_notifies(self):
         """
@@ -1949,19 +1869,23 @@ Failed to reset the connection to the server due to following error:
                          'pid': notify.pid
                          } for notify in self.__notifies
                         ]
+            self.__notifies = None
         return notifies
 
-    def get_notices(self):
+    def get_notices(self, diag=None):
         """
         This function will returns the notices as string.
         :return:
         """
         notices = ''
         # Check for notices.
-        if self.conn.notices and self.__notices is not None:
-            self.__notices.extend(self.conn.notices)
-            self.conn.notices.clear()
+        if diag and hasattr(diag, 'message_primary'):
+            if self.__notices is None:
+                self.__notices = []
+            self.__notices.append(f"{diag.severity}:"
+                                  f"  {diag.message_primary}\n")
 
+        if diag is None:
             while self.__notices:
                 notices += self.__notices.pop(0)
 
@@ -1970,35 +1894,20 @@ Failed to reset the connection to the server due to following error:
     def pq_encrypt_password_conn(self, password, user):
         """
         This function will return the encrypted password for database server
-        greater than or equal to 10
         :param password: password to be encrypted
         :param user: user of the database server
         :return:
         """
         enc_password = None
-        if psycopg2.__libpq_version__ >= 100000 and \
-                hasattr(psycopg2.extensions, 'encrypt_password'):
-            if self.connected():
-                status, enc_algorithm = \
-                    self.execute_scalar("SHOW password_encryption")
-                if status:
-                    enc_password = psycopg2.extensions.encrypt_password(
-                        password=password, user=user, scope=self.conn,
-                        algorithm=enc_algorithm
-                    )
-        elif psycopg2.__libpq_version__ < 100000:
-            current_app.logger.warning(
-                "To encrypt passwords the required libpq version is "
-                "greater than or equal to 100000. Current libpq version "
-                "is {curr_ver}".format(
-                    curr_ver=psycopg2.__libpq_version__
-                )
-            )
-        elif not hasattr(psycopg2.extensions, 'encrypt_password'):
-            current_app.logger.warning(
-                "The psycopg2.extensions module does not have the"
-                "'encrypt_password' method."
-            )
+        if self.connected():
+            status, enc_algorithm = \
+                self.execute_scalar("SHOW password_encryption")
+            if status:
+                encoding = self.conn.info.encoding
+                enc_password = self.conn.pgconn.encrypt_password(
+                    password.encode(encoding), user.encode(encoding),
+                    enc_algorithm.encode(encoding)
+                ).decode()
 
         return enc_password
 
@@ -2015,7 +1924,7 @@ Failed to reset the connection to the server due to following error:
         else:
 
             if parameters:
-                mogrified_sql = cursor.mogrify(query, parameters)
-                return mogrified_sql
+                return psycopg.sql.SQL(query.format(parameters)
+                                       ).as_string(self.conn)
             else:
                 return query
diff --git a/web/pgadmin/utils/driver/psycopg2/cursor.py b/web/pgadmin/utils/driver/psycopg3/cursor.py
similarity index 56%
rename from web/pgadmin/utils/driver/psycopg2/cursor.py
rename to web/pgadmin/utils/driver/psycopg3/cursor.py
index f58460d2d..c73774d9c 100644
--- a/web/pgadmin/utils/driver/psycopg2/cursor.py
+++ b/web/pgadmin/utils/driver/psycopg3/cursor.py
@@ -13,10 +13,15 @@ fetching results from it, and also takes care of the duplicate column name in
 result.
 """
 
-
+import asyncio
 from collections import OrderedDict
-import psycopg2
-from psycopg2.extensions import cursor as _cursor, encodings
+import psycopg
+from psycopg import Cursor as _cursor, AsyncCursor as _async_cursor
+from typing import Any, Sequence
+from psycopg.rows import dict_row, tuple_row
+from psycopg._encodings import py_codecs as encodings
+
+
 from .encoding import configure_driver_encodings
 
 configure_driver_encodings(encodings)
@@ -90,10 +95,6 @@ class _WrapperColumn(object):
         with avoiding the duplicate name.
         """
 
-        # In psycopg2 2.8, the description of one result column,
-        # exposed as items of the cursor.description sequence.
-        # Before psycopg2 2.8 the description attribute was a sequence
-        # of simple tuples or namedtuples.
         ores = OrderedDict()
         ores['name'] = self.orig_col.name
         ores['type_code'] = self.orig_col.type_code
@@ -134,11 +135,8 @@ class DictCursor(_cursor):
     """
 
     def __init__(self, *args, **kwargs):
-        """
-        Initialize the cursor object.
-        """
         self._odt_desc = None
-        _cursor.__init__(self, *args, **kwargs)
+        _cursor.__init__(self, *args, row_factory=dict_row)
 
     def _dict_tuple(self, tup):
         """
@@ -154,6 +152,7 @@ class DictCursor(_cursor):
         duplicate column name.
         """
         self._odt_desc = _cursor.__getattribute__(self, 'description')
+        pgresult = _cursor.__getattribute__(self, 'pgresult')
         desc = self._odt_desc
 
         if desc is None or len(desc) == 0:
@@ -161,6 +160,7 @@ class DictCursor(_cursor):
 
         res = list()
         od = dict((d[0], 0) for d in desc)
+        col_count = 0
         for d in desc:
             dummy = None
             idx = od[d.name]
@@ -173,6 +173,9 @@ class DictCursor(_cursor):
                     name = ("%s-%s" % (d.name, idx))
                     od[d.name] = idx
                 dummy = name
+            if pgresult:
+                d.table_oid = pgresult.ftable(col_count)
+                d.table_column = pgresult.ftablecol(col_count)
             res.append(_WrapperColumn(d, dummy))
         self._odt_desc = tuple(res)
 
@@ -194,42 +197,176 @@ class DictCursor(_cursor):
 
         return _cursor.execute(self, query, params)
 
-    def executemany(self, query, params=None):
+    def fetchone(self):
         """
-        Execute many function of regular cursor.
+        Execute function
+        """
+        self.row_factory = tuple_row
+        res = _cursor.fetchone(self)
+        self.row_factory = dict_row
+        return res
+
+    def get_rowcount(self):
+        return self.pgresult.ntuples
+
+
+class AsyncDictCursor(_async_cursor):
+
+    def __init__(self, *args, **kwargs):
+        self._odt_desc = None
+        _async_cursor.__init__(self, *args, row_factory=dict_row)
+
+    def _dict_tuple(self, tup):
+        """
+        Transform the tuple into a dictionary object.
+        """
+        if self._odt_desc is None:
+            self._ordered_description()
+        return dict((k[0], v) for k, v in zip(self._odt_desc, tup))
+
+    def _ordered_description(self):
+        """
+        Transform the regular description to wrapper object, which handles
+        duplicate column name.
+        """
+        self._odt_desc = _async_cursor.__getattribute__(self, 'description')
+        pgresult = _async_cursor.__getattribute__(self, 'pgresult')
+        desc = self._odt_desc
+
+        if desc is None or len(desc) == 0:
+            return
+
+        res = list()
+        od = dict((d[0], 0) for d in desc)
+        col_count = 0
+        for d in desc:
+            dummy = None
+            idx = od[d.name]
+            if idx == 0:
+                od[d.name] = 1
+            else:
+                name = d.name
+                while name in od:
+                    idx += 1
+                    name = ("%s-%s" % (d.name, idx))
+                    od[d.name] = idx
+                dummy = name
+            if pgresult:
+                d.table_oid = pgresult.ftable(col_count)
+                d.table_column = pgresult.ftablecol(col_count)
+                col_count += 1
+
+            res.append(_WrapperColumn(d, dummy))
+        self._odt_desc = tuple(res)
+
+    def ordered_description(self):
+        """
+        Use this to fetch the description
+        """
+        if self._odt_desc is None:
+            self._ordered_description()
+        return self._odt_desc
+
+    def execute(self, query, params=None):
+        """
+        Execute function
+        """
+        return asyncio.run(self._execute(query, params))
+
+    async def _execute(self, query, params=None):
+        """
+        Execute function
         """
         self._odt_desc = None
-        return _cursor.executemany(self, query, params)
+        if params is not None and len(params) == 0:
+            params = None
 
-    def callproc(self, proname, params=None):
+        return await _async_cursor.execute(self, query, params)
+
+    def executemany(self, query, params=None):
         """
-        Call a procedure by a name.
+        Execute many function of regular cursor.
         """
         self._odt_desc = None
-        return _cursor.callproc(self, proname, params)
+        return _async_cursor.executemany(self, query, params)
 
     def fetchmany(self, size=None):
         """
         Fetch many tuples as ordered dictionary list.
         """
-        tuples = _cursor.fetchmany(self, size)
-        if tuples is not None:
-            return [self._dict_tuple(t) for t in tuples]
-        return None
+        return asyncio.run(self._fetchmany(size))
+
+    async def _fetchmany(self, size=None):
+        """
+        Fetch many tuples as ordered dictionary list.
+        """
+        return await _async_cursor.fetchmany(self, size)
+
+    async def _fetchall(self):
+        """
+        Fetch all tuples as ordered dictionary list.
+        """
+        return await _async_cursor.fetchall(self)
 
     def fetchall(self):
         """
         Fetch all tuples as ordered dictionary list.
         """
-        tuples = _cursor.fetchall(self)
-        if tuples is not None:
-            return [self._dict_tuple(t) for t in tuples]
-
-    def __iter__(self):
-        it = _cursor.__iter__(self)
-        try:
-            yield self._dict_tuple(next(it))
-            while True:
-                yield self._dict_tuple(next(it))
-        except StopIteration:
-            pass
+        return asyncio.run(self._fetchall())
+
+    async def _fetchalltupple(self):
+        """
+        Fetch all tuples as ordered dictionary list.
+        """
+        return await _async_cursor.fetchall(self)
+
+    def fetchalltupple(self):
+        """
+        Fetch all tuples as ordered dictionary list.
+        """
+        self.row_factory = tuple_row
+        res = asyncio.run(self._fetchalltupple())
+        self.row_factory = dict_row
+        return res
+
+    async def _fetchone(self):
+        """
+        Fetch all tuples as ordered dictionary list.
+        """
+        return await _async_cursor.fetchone(self)
+
+    def fetchone(self):
+        """
+        Execute function
+        """
+        self.row_factory = tuple_row
+        res = asyncio.run(self._fetchone())
+        self.row_factory = dict_row
+        return res
+
+    async def _scrollcur(self, position, mode):
+        """
+        Fetch all tuples as ordered dictionary list.
+        """
+        return await _async_cursor.scroll(self, position, mode=mode)
+
+    def scroll(self, position, mode="absolute"):
+        """
+        Fetch all tuples as ordered dictionary list.
+        """
+        return asyncio.run(self._scrollcur(position, mode))
+
+    def get_rowcount(self):
+        if self.pgresult:
+            return self.pgresult.ntuples
+        else:
+            return -1
+
+    async def _closecur(self):
+        """
+        Fetch all tuples as ordered dictionary list.
+        """
+        return await _async_cursor.close(self)
+
+    async def close(self):
+        return asyncio.run(self._closecur())
diff --git a/web/pgadmin/utils/driver/psycopg3/encoding.py b/web/pgadmin/utils/driver/psycopg3/encoding.py
new file mode 100644
index 000000000..9b9265e50
--- /dev/null
+++ b/web/pgadmin/utils/driver/psycopg3/encoding.py
@@ -0,0 +1,59 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+#  Get Postgres and Python encoding
+
+import psycopg
+
+encode_dict = {
+    'SQL_ASCII': ['SQL_ASCII', 'raw-unicode-escape', 'unicode-escape'],
+    # EUC_TW Not availble in Python,
+    # so psycopg3 do not support it, we are on our own
+    'EUC_TW': ['BIG5', 'big5', 'big5']
+}
+
+
+def get_encoding(key):
+    """
+    :param key: Database Encoding
+    :return:
+    [Postgres_encoding, Python_encoding, typecast_encoding] -
+    Postgres encoding, Python encoding, type cast encoding
+    """
+    #
+    # Reference: https://www.postgresql.org/docs/11/multibyte.html
+
+    if key == 'ascii':
+        key = 'raw_unicode_escape'
+    postgres_encoding = psycopg._encodings.py2pgenc(key).decode()
+
+    python_encoding = psycopg._encodings._py_codecs.get(postgres_encoding,
+                                                        'utf-8')
+
+    return encode_dict.get(postgres_encoding.upper(),
+                           [postgres_encoding,
+                            python_encoding,
+                            python_encoding])
+
+
+def configure_driver_encodings(encodings):
+    # Replace the python encoding for original name and renamed encodings
+    # psycopg removes the underscore in conn.encoding
+    # Setting the encodings dict value will only help for select statements
+    # because for parameterized DML, param values are converted based on
+    # python encoding of pyscopg's internal encodings dict.
+
+    for key, val in encode_dict.items():
+        postgres_encoding, python_encoding, typecast_encoding = val
+        psycopg._encodings._py_codecs[key] = python_encoding
+
+    encodings.update((k.encode(), v
+                      ) for k, v in psycopg._encodings._py_codecs.items())
+    psycopg._encodings.pg_codecs = {
+        v: k.encode() for k, v in psycopg._encodings._py_codecs.items()}
